searchNodes=[{"doc":"Authentication &amp; sessions for API's.","ref":"Charon.html","title":"Charon","type":"module"},{"doc":"Config struct. Keys &amp; defaults: [ :token_issuer , access_cookie_name : &quot;_access_token_signature&quot; , access_cookie_opts : [ http_only : true , same_site : &quot;Strict&quot; , secure : true ] , # 15 minutes access_token_ttl : 15 * 60 , optional_modules : %{ } , refresh_cookie_name : &quot;_refresh_token_signature&quot; , refresh_cookie_opts : [ http_only : true , same_site : &quot;Strict&quot; , secure : true ] , # 2 months refresh_token_ttl : 2 * 30 * 24 * 60 * 60 , session_store_module : Charon.SessionStore.RedisStore , # 1 year session_ttl : 365 * 24 * 60 * 60 , token_factory_module : Charon.TokenFactory.SymmetricJwt ] Note that all config is compile-time config. Runtime configuration properties should be provided in the form of getters, like the config of Charon.TokenFactory.SymmetricJwt .","ref":"Charon.Config.html","title":"Charon.Config","type":"module"},{"doc":"Build config struct from enumerable (useful for passing in application environment). Raises for missing mandatory keys and sets defaults for optional keys. Optional modules must implement an init_config/1 function to process their own config at compile time. Examples / doctests iex&gt; from_enum ( [ ] ) ** (ArgumentError) the following keys must also be given when building struct Charon.Config: [:token_issuer] iex&gt; % Charon.Config { } = from_enum ( token_issuer : &quot;https://myapp&quot; ) # optional modules may also check compile-time config iex&gt; from_enum ( token_issuer : &quot;Santa&quot; , optional_modules : %{ Charon.TokenFactory.SymmetricJwt =&gt; [ ] } ) ** (ArgumentError) the following keys must also be given when building struct Charon.TokenFactory.SymmetricJwt.Config: [:get_secret]","ref":"Charon.Config.html#from_enum/1","title":"Charon.Config.from_enum/1","type":"function"},{"doc":"","ref":"Charon.Config.html#t:t/0","title":"Charon.Config.t/0","type":"type"},{"doc":"A session.","ref":"Charon.Models.Session.html","title":"Charon.Models.Session","type":"module"},{"doc":"Deserialize a session, without breaking for structural changes in the session struct. DocTests @charon_config Charon.Config . from_enum ( token_issuer : &quot;local&quot; ) # serialization is reversible iex&gt; % Session { } = @charon_config |&gt; new ( ) |&gt; serialize ( ) |&gt; deserialize ( ) # old version - without the :version field - is deserialized without error iex&gt; serialized = &quot;g3QAAAAIZAAKY3JlYXRlZF9hdGJjdlx6ZAAKZXhwaXJlc19hdGJlV4/6ZAANZXh0cmFfcGF5bG9hZHQAAAAAZAACaWRtAAAAFk1xMk0xRUlJUTFKV1dMTEZBSnk2YndkABByZWZyZXNoX3Rva2VuX2lkbQAAAANhYmNkAAxyZWZyZXNoZWRfYXRhAGQABHR5cGVkAARmdWxsZAAHdXNlcl9pZGEB&quot; iex&gt; serialized |&gt; Base . decode64! ( ) |&gt; deserialize ( ) % Charon.Models.Session { created_at : 1668701306 , id : &quot;Mq2M1EIIQ1JWWLLFAJy6bw&quot; , user_id : 1 , expires_at : 1700237306 , refresh_token_id : &quot;abc&quot; , refreshed_at : 0 , type : :full , extra_payload : %{ } , version : 1 } # old version - with :expires_at = nil - is deserialized without error iex&gt; % Session { expires_at : :infinite } = @charon_config |&gt; new ( expires_at : nil ) |&gt; serialize ( ) |&gt; deserialize ( )","ref":"Charon.Models.Session.html#deserialize/1","title":"Charon.Models.Session.deserialize/1","type":"function"},{"doc":"Create a new session from config values and overrides. Provides defaults for :id , :created_at and :expires_at .","ref":"Charon.Models.Session.html#new/2","title":"Charon.Models.Session.new/2","type":"function"},{"doc":"Serialize a session.","ref":"Charon.Models.Session.html#serialize/1","title":"Charon.Models.Session.serialize/1","type":"function"},{"doc":"","ref":"Charon.Models.Session.html#t:t/0","title":"Charon.Models.Session.t/0","type":"type"},{"doc":"Tokens to be communicated to the client.","ref":"Charon.Models.Tokens.html","title":"Charon.Models.Tokens","type":"module"},{"doc":"","ref":"Charon.Models.Tokens.html#t:t/0","title":"Charon.Models.Tokens.t/0","type":"type"},{"doc":"Plugs to create, update/refresh and delete sessions. When creating or updating a session, new tokens are created as well.","ref":"Charon.SessionPlugs.html","title":"Charon.SessionPlugs","type":"module"},{"doc":"Delete the persistent session identified by the session_id in the token claims. Note that the token remains valid until it expires, it is left up to the client to drop the access token. It will no longer be possible to refresh the session, however. Examples / doctests # instructs browsers to clear signature cookies iex&gt; conn ( ) ...&gt; |&gt; Plug.Test . put_req_cookie ( @config . access_cookie_name , &quot;anything&quot; ) ...&gt; |&gt; Plug.Test . put_req_cookie ( @config . refresh_cookie_name , &quot;anything&quot; ) ...&gt; |&gt; delete_session ( @config ) ...&gt; |&gt; Conn . fetch_cookies ( ) ...&gt; |&gt; Map . get ( :cookies ) %{ }","ref":"Charon.SessionPlugs.html#delete_session/2","title":"Charon.SessionPlugs.delete_session/2","type":"function"},{"doc":"Create or update a session. If a session exists in the conn, the session is updated / refreshed, otherwise a new one is created. Refresh an existing session by putting it on the connection with Charon.TokenPlugs.load_session/2 . In both cases, new access / refresh tokens are created and stored in the conn's private map. The server-side session stored in the session store is created / updated as well. If a new session is created, this plug must be preceded by Charon.Utils.set_token_signature_transport/2 and Charon.Utils.set_user_id/2 or an error will be raised. The tokens' signatures are split off and sent as cookies if the session's token signature transport mechanism is set to :cookie . By default, these are http-only strictly-same-site secure cookies. Optionally, it is possible to add extra claims to the access- and refresh tokens or to store extra payload in the server-side session. Raises on session store errors. No recovery is possible from this error - the session HAS to be stored or there is no point in handing out tokens. Claims The following claims are set by default: &quot;exp&quot; expires at (this value is guaranteed to never outlive the session itself) &quot;iat&quot; time of token creation &quot;iss&quot; issuer, usually a url like &quot; https://myapp.com&quot; &quot;jti&quot; jwt id, random unique id for the token (a refresh token's id is stored in the session as well) &quot;nbf&quot; not before, same value as &quot;iat&quot; but means &quot;token not valid before this time&quot; &quot;sid&quot; session id &quot;sub&quot; subject, the user id of the session owner &quot;type&quot; type, &quot;access&quot; or &quot;refresh&quot; Additional claims or overrides can be provided with opts . Examples / doctests # error if user id not set for new session iex&gt; % Conn { } |&gt; Utils . set_token_signature_transport ( :bearer ) |&gt; upsert_session ( @config ) ** (RuntimeError) Set user id using Utils.set_user_id/2 # error if signature transport not set for new session iex&gt; % Conn { } |&gt; Utils . set_user_id ( 1 ) |&gt; upsert_session ( @config ) ** (RuntimeError) Set token signature transport using Utils.set_token_signature_transport/2 # creates session if none present in conn iex&gt; conn = conn ( ) ...&gt; |&gt; Utils . set_user_id ( 1 ) ...&gt; |&gt; Utils . set_token_signature_transport ( :bearer ) ...&gt; |&gt; upsert_session ( @config ) iex&gt; % Session { } = Utils . get_session ( conn ) iex&gt; % Tokens { } = Utils . get_tokens ( conn ) # renews session if present in conn, updating only refresh_token_id, refreshed_at # existing session&#39;s user id will not change despite attempted override iex&gt; old_session = % Session { user_id : 43 , id : &quot;a&quot; , expires_at : :infinite } iex&gt; conn = conn ( ) ...&gt; |&gt; Conn . put_private ( @session , old_session ) ...&gt; |&gt; Utils . set_token_signature_transport ( :bearer ) ...&gt; |&gt; Utils . set_user_id ( 1 ) ...&gt; |&gt; upsert_session ( @config ) iex&gt; session = Utils . get_session ( conn ) |&gt; Map . from_struct ( ) iex&gt; old_session = Map . from_struct ( old_session ) iex&gt; Enum . map ( ~w(id user_id created_at expires_at)a , &amp; session [ &amp;1 ] == old_session [ &amp;1 ] ) [ true , true , true , true ] iex&gt; Enum . map ( ~w(refresh_token_id refreshed_at)a , &amp; session [ &amp;1 ] == old_session [ &amp;1 ] ) [ false , false ] # returns signatures in cookies if requested, which removes signatures from tokens iex&gt; conn = conn ( ) ...&gt; |&gt; Utils . set_token_signature_transport ( :cookie ) ...&gt; |&gt; Utils . set_user_id ( 1 ) ...&gt; |&gt; upsert_session ( @config ) iex&gt; cookies = conn |&gt; Conn . fetch_cookies ( ) |&gt; Map . get ( :cookies ) iex&gt; &lt;&lt; _access_sig :: binary &gt;&gt; = Map . get ( cookies , @config . access_cookie_name ) iex&gt; &lt;&lt; _refresh_sig :: binary &gt;&gt; = Map . get ( cookies , @config . refresh_cookie_name ) iex&gt; true = Regex . match? ( ~r/ \\w + \\. \\w + \\. / , conn |&gt; Utils . get_tokens ( ) |&gt; Map . get ( :access_token ) ) iex&gt; true = Regex . match? ( ~r/ \\w + \\. \\w + \\. / , conn |&gt; Utils . get_tokens ( ) |&gt; Map . get ( :refresh_token ) ) # tokens get a lot of default claims iex&gt; conn = conn ( ) ...&gt; |&gt; Utils . set_token_signature_transport ( :bearer ) ...&gt; |&gt; Utils . set_user_id ( 1 ) ...&gt; |&gt; upsert_session ( @config ) iex&gt; %{ &quot;exp&quot; =&gt; _ , &quot;iat&quot; =&gt; _ , &quot;iss&quot; =&gt; &quot;my_test_app&quot; , &quot;jti&quot; =&gt; &lt;&lt; _ :: binary &gt;&gt; , &quot;nbf&quot; =&gt; _ , &quot;sid&quot; =&gt; &lt;&lt; sid :: binary &gt;&gt; , &quot;sub&quot; =&gt; 1 , &quot;type&quot; =&gt; &quot;access&quot; } = get_private ( conn , @access_token_payload ) iex&gt; %{ &quot;exp&quot; =&gt; _ , &quot;iat&quot; =&gt; _ , &quot;iss&quot; =&gt; &quot;my_test_app&quot; , &quot;jti&quot; =&gt; &lt;&lt; _ :: binary &gt;&gt; , &quot;nbf&quot; =&gt; _ , &quot;sid&quot; =&gt; ^ sid , &quot;sub&quot; =&gt; 1 , &quot;type&quot; =&gt; &quot;refresh&quot; } = get_private ( conn , @refresh_token_payload ) # allows adding extra claims to tokens iex&gt; conn = conn ( ) ...&gt; |&gt; Utils . set_token_signature_transport ( :bearer ) ...&gt; |&gt; Utils . set_user_id ( 1 ) ...&gt; |&gt; upsert_session ( @config , access_claim_overrides : %{ &quot;much&quot; =&gt; :extra } , refresh_claim_overrides : %{ &quot;really&quot; =&gt; true } ) iex&gt; %{ &quot;much&quot; =&gt; :extra } = get_private ( conn , @access_token_payload ) iex&gt; %{ &quot;really&quot; =&gt; true } = get_private ( conn , @refresh_token_payload ) # allows adding extra payload to session iex&gt; conn = conn ( ) ...&gt; |&gt; Utils . set_user_id ( 1 ) ...&gt; |&gt; Utils . set_token_signature_transport ( :bearer ) ...&gt; |&gt; upsert_session ( @config , extra_session_payload : %{ what? : &quot;that&#39;s right!&quot; } ) iex&gt; % Session { extra_payload : %{ what? : &quot;that&#39;s right!&quot; } } = Utils . get_session ( conn )","ref":"Charon.SessionPlugs.html#upsert_session/3","title":"Charon.SessionPlugs.upsert_session/3","type":"function"},{"doc":"","ref":"Charon.SessionPlugs.html#t:upsert_session_opts/0","title":"Charon.SessionPlugs.upsert_session_opts/0","type":"type"},{"doc":"Entrypoint for Charon.SessionStore.Behaviour implementation. All functions delegate to the configured module.","ref":"Charon.SessionStore.html","title":"Charon.SessionStore","type":"module"},{"doc":"Behaviour definition of a persistent session store. The implementation is expected to handle cleanup of expired entries. All three callbacks can use only a session ID, and ignore the user ID that is passed in as well, because a session ID is a unique 128-bits binary by itself. However, not ignoring the user ID enables the usecase where all sessions for a user are fetched or deleted (the optional callbacks), for example, so there are benefits to storing sessions per user.","ref":"Charon.SessionStore.Behaviour.html","title":"Charon.SessionStore.Behaviour","type":"behaviour"},{"doc":"Delete session with id session_id for user with id user_id . Implementations may choose to ignore user_id , since session_id is unique by itself.","ref":"Charon.SessionStore.Behaviour.html#c:delete/3","title":"Charon.SessionStore.Behaviour.delete/3","type":"callback"},{"doc":"Delete all sessions for the user with id user_id .","ref":"Charon.SessionStore.Behaviour.html#c:delete_all/2","title":"Charon.SessionStore.Behaviour.delete_all/2","type":"callback"},{"doc":"Get session with id session_id for user with id user_id . Implementations may choose to ignore user_id , since session_id is unique by itself.","ref":"Charon.SessionStore.Behaviour.html#c:get/3","title":"Charon.SessionStore.Behaviour.get/3","type":"callback"},{"doc":"Get all sessions for the user with id user_id .","ref":"Charon.SessionStore.Behaviour.html#c:get_all/2","title":"Charon.SessionStore.Behaviour.get_all/2","type":"callback"},{"doc":"Insert or update session , with time-to-live ttl . The session_id and user_id are taken from the session struct. Implementations may choose to ignore user_id , since session_id is unique by itself.","ref":"Charon.SessionStore.Behaviour.html#c:upsert/3","title":"Charon.SessionStore.Behaviour.upsert/3","type":"callback"},{"doc":"A dummy session store that can be used if fully stateless tokens are desired.","ref":"Charon.SessionStore.DummyStore.html","title":"Charon.SessionStore.DummyStore","type":"module"},{"doc":"A persistent session store based on Redis, which implements behaviour Charon.SessionStore . In addition to the required callbacks, this store also provides get_all/2 and delete_all/2 (for a user) functions. Config Additional config is required for this module (see Charon.SessionStore.RedisStore.Config ): Charon.Config . from_enum ( ... , optional_modules : %{ Charon.SessionStore.RedisStore =&gt; %{ redix_module : MyApp.Redix , key_prefix : &quot;charon_&quot; } } ) The following options are supported: :redix_module (required). A module that implements a command/1 and a pipeline/1 function for Redis commands like Redix. :key_prefix (optional). A string prefix for the Redis keys that are sessions. Redix This module depends on a correctly configured Redix module with command/1 and pipeline/1 functions. See https://hexdocs.pm/redix for instructions. Cleanup Session keys slowly accumulate in Redis when using this store. It provides a cleanup/1 that should run periodically.","ref":"Charon.SessionStore.RedisStore.html","title":"Charon.SessionStore.RedisStore","type":"module"},{"doc":"This should run periodically, for example once per day at a quiet moment.","ref":"Charon.SessionStore.RedisStore.html#cleanup/1","title":"Charon.SessionStore.RedisStore.cleanup/1","type":"function"},{"doc":"Config module for Charon.SessionStore.RedisStore .","ref":"Charon.SessionStore.RedisStore.Config.html","title":"Charon.SessionStore.RedisStore.Config","type":"module"},{"doc":"Build config struct from enumerable (useful for passing in application environment). Raises for missing mandatory keys and sets defaults for optional keys.","ref":"Charon.SessionStore.RedisStore.Config.html#from_enum/1","title":"Charon.SessionStore.RedisStore.Config.from_enum/1","type":"function"},{"doc":"","ref":"Charon.SessionStore.RedisStore.Config.html#t:t/0","title":"Charon.SessionStore.RedisStore.Config.t/0","type":"type"},{"doc":"Entrypoint for Charon.TokenFactory.Behaviour implementation. All functions delegate to the configured module.","ref":"Charon.TokenFactory.html","title":"Charon.TokenFactory","type":"module"},{"doc":"Behaviour for token-signing modules. Note that the token payload must be returned as a map with string keys on verification. When the payload is serialized as JSON, this happens automatically. However, when Erlang term format is used, this is not the case.","ref":"Charon.TokenFactory.Behaviour.html","title":"Charon.TokenFactory.Behaviour","type":"behaviour"},{"doc":"Create a new token with the provided payload and a valid signature.","ref":"Charon.TokenFactory.Behaviour.html#c:sign/2","title":"Charon.TokenFactory.Behaviour.sign/2","type":"callback"},{"doc":"Verify that the signature matches the token's header and payload, and decode the payload. Must return a map of string keys.","ref":"Charon.TokenFactory.Behaviour.html#c:verify/2","title":"Charon.TokenFactory.Behaviour.verify/2","type":"callback"},{"doc":"The default and most simple form of self-signed tokens, JWTs with symmetric-key signatures. These are suited for everything but OpenID Connect implementations, because these require third parties to verify the token signature, which requires asymetric keys. Config Additional config is required for this module (see Charon.TokenFactory.SymmetricJwt.Config ): Charon.Config . from_enum ( ... , optional_modules : %{ Charon.TokenFactory.SymmetricJwt =&gt; %{ get_secret : fn -&gt; :crypto . strong_rand_bytes ( 32 ) end , algorithm : :poly1305 , json_module : Jason } } ) The following options are supported: :get_secret (required). A getter/0 for secret for the JWT's signature algorithm. Must be exactly 256 bits in case of Poly1305 alg. :algorithm (optional). The token signature algorithm, may be :sha256 (default), :sha384 , :sha512 or :poly1305 . :json_module (optional, default Jason). The JSON encoding lib. Examples / doctests # verify ignores the config&#39;s algorithm, grabbing it from the JWT header instead # this allows changing algorithms without invalidating existing JWTs iex&gt; get_secret = fn -&gt; &quot;symmetric key&quot; end iex&gt; config = %{ optional_modules : %{ SymmetricJwt =&gt; SymmetricJwt.Config . from_enum ( get_secret : get_secret ) } } iex&gt; payload = %{ &quot;iss&quot; =&gt; &quot;joe&quot; , &quot;exp&quot; =&gt; 1_300_819_380 , &quot;http://example.com/is_root&quot; =&gt; true } iex&gt; { :ok , token } = sign ( payload , config ) { :ok , &quot;eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJleHAiOjEzMDA4MTkzODAsImh0dHA6Ly9leGFtcGxlLmNvbS9pc19yb290Ijp0cnVlLCJpc3MiOiJqb2UifQ.shLcxOl_HBBsOTvPnskfIlxHUibPN7Y9T4LhPB-iBwM&quot; } iex&gt; config = %{ optional_modules : %{ SymmetricJwt =&gt; SymmetricJwt.Config . from_enum ( get_secret : get_secret , algorithm : :sha512 ) } } iex&gt; { :ok , ^ payload } = verify ( token , config ) iex&gt; get_secret = fn -&gt; &quot;symmetric key&quot; end iex&gt; config = %{ optional_modules : %{ SymmetricJwt =&gt; SymmetricJwt.Config . from_enum ( get_secret : get_secret ) } } iex&gt; verify ( &quot;a&quot; , config ) { :error , &quot;malformed token&quot; } iex&gt; verify ( &quot;a.b.c&quot; , config ) { :error , &quot;encoding invalid&quot; } iex&gt; header = %{ &quot;alg&quot; =&gt; &quot;boom&quot; } |&gt; Jason . encode! ( ) |&gt; Base . url_encode64 ( padding : false ) iex&gt; verify ( header &lt;&gt; &quot;.YQ.YQ&quot; , config ) { :error , &quot;unsupported signature algorithm&quot; } iex&gt; header = %{ &quot;alg&quot; =&gt; &quot;HS256&quot; } |&gt; Jason . encode! ( ) |&gt; Base . url_encode64 ( padding : false ) iex&gt; verify ( header &lt;&gt; &quot;.YQ.YQ&quot; , config ) { :error , &quot;signature invalid&quot; } # poly1305 is experimentally supported, and requires a 256-bits key iex&gt; secret = :crypto . strong_rand_bytes ( 32 ) iex&gt; get_secret = fn -&gt; secret end iex&gt; config = %{ optional_modules : %{ SymmetricJwt =&gt; SymmetricJwt.Config . from_enum ( get_secret : get_secret , algorithm : :poly1305 ) } } iex&gt; payload = %{ &quot;iss&quot; =&gt; &quot;joe&quot; , &quot;exp&quot; =&gt; 1_300_819_380 , &quot;http://example.com/is_root&quot; =&gt; true } iex&gt; { :ok , token } = sign ( payload , config ) iex&gt; { :ok , ^ payload } = verify ( token , config ) iex&gt; header = token |&gt; String . split ( &quot;.&quot; ) |&gt; List . first ( ) |&gt; Base . url_decode64! ( ) |&gt; Jason . decode! ( ) iex&gt; %{ &quot;alg&quot; =&gt; &quot;Poly1305&quot; , &quot;nonce&quot; =&gt; &lt;&lt; _ :: binary &gt;&gt; , &quot;typ&quot; =&gt; &quot;JWT&quot; } = header iex&gt; config = %{ optional_modules : %{ SymmetricJwt =&gt; SymmetricJwt.Config . from_enum ( get_secret : fn -&gt; :crypto . strong_rand_bytes ( 32 ) end ) } } iex&gt; { :error , &quot;signature invalid&quot; } = verify ( token , config )","ref":"Charon.TokenFactory.SymmetricJwt.html","title":"Charon.TokenFactory.SymmetricJwt","type":"module"},{"doc":"Config module for Charon.TokenFactory.SymmetricJwt .","ref":"Charon.TokenFactory.SymmetricJwt.Config.html","title":"Charon.TokenFactory.SymmetricJwt.Config","type":"module"},{"doc":"Build config struct from enumerable (useful for passing in application environment). Raises for missing mandatory keys and sets defaults for optional keys.","ref":"Charon.TokenFactory.SymmetricJwt.Config.html#from_enum/1","title":"Charon.TokenFactory.SymmetricJwt.Config.from_enum/1","type":"function"},{"doc":"","ref":"Charon.TokenFactory.SymmetricJwt.Config.html#t:t/0","title":"Charon.TokenFactory.SymmetricJwt.Config.t/0","type":"type"},{"doc":"The plugs in this module (and its submodules) can be used to verify tokens. The token's presence, signature, expiration and any claims can be checked. Additionally, the token's session can be loaded and, in case of a refresh token, it can be verified that it matches the session. In case of validation errors, the plugs add an &quot;auth error&quot; to the conn, but don't raise or halt the connection immediately. This property can be used to support endpoints that work with- or without authentication, for example, or if you want to support multiple kinds of tokens. The plug verify_no_auth_error/2 can be used to actually do something if there is an error. All the plugs short-circuit, meaning that they immediately return the connection if there are errors. Using the plugs in these module, you can construct your own verification pipeline using either Plug.Builder or standard Phoenix router pipelines. Here are two examples for access- and refresh tokens, respectively, that should be a good baseline for your own pipelines. Access tokens defmodule MyApp.AccessTokenPipeline do use Plug.Builder @config Charon.Config . from_enum ( Application . compile_env! ( :my_app , :charon ) ) plug :get_token_from_auth_header plug :get_token_sig_from_cookie , @config . access_cookie_name plug :verify_token_signature , @config plug :verify_token_nbf_claim plug :verify_token_exp_claim plug :verify_token_claim_equals , { &quot;type&quot; , &quot;access&quot; } plug :verify_no_auth_error , &amp; MyApp.TokenErrorHandler . on_error / 2 plug Charon.TokenPlugs.PutAssigns end Refresh tokens defmodule MyApp.RefreshTokenPipeline do use Plug.Builder @config Charon.Config . from_enum ( Application . compile_env! ( :my_app , :charon ) ) plug :get_token_from_auth_header plug :get_token_sig_from_cookie , @config . refresh_cookie_name plug :verify_token_signature , @config plug :verify_token_nbf_claim plug :verify_token_exp_claim plug :verify_token_claim_equals , { &quot;type&quot; , &quot;refresh&quot; } plug :load_session , @config plug :verify_refresh_token_fresh plug :verify_no_auth_error , &amp; MyApp.TokenErrorHandler . on_error / 2 plug Charon.TokenPlugs.PutAssigns end","ref":"Charon.TokenPlugs.html","title":"Charon.TokenPlugs","type":"module"},{"doc":"Get a bearer token from the authorization header. Doctests iex&gt; conn = conn ( ) |&gt; put_req_header ( &quot;authorization&quot; , &quot;Bearer aaa&quot; ) iex&gt; conn |&gt; get_token_from_auth_header ( [ ] ) |&gt; Utils . get_auth_error ( ) nil iex&gt; conn |&gt; get_token_from_auth_header ( [ ] ) |&gt; Utils . get_token_signature_transport ( ) :bearer iex&gt; conn |&gt; get_token_from_auth_header ( [ ] ) |&gt; Internal . get_private ( @bearer_token ) &quot;aaa&quot; # missing auth header iex&gt; conn = conn ( ) iex&gt; conn |&gt; get_token_from_auth_header ( [ ] ) |&gt; Utils . get_auth_error ( ) &quot;bearer token not found&quot; # auth header format must be correct iex&gt; conn = conn ( ) |&gt; put_req_header ( &quot;authorization&quot; , &quot;boom&quot; ) iex&gt; conn |&gt; get_token_from_auth_header ( [ ] ) |&gt; Utils . get_auth_error ( ) &quot;bearer token not found&quot; iex&gt; conn = conn ( ) |&gt; put_req_header ( &quot;authorization&quot; , &quot;Bearer &quot; ) iex&gt; conn |&gt; get_token_from_auth_header ( [ ] ) |&gt; Utils . get_auth_error ( ) &quot;bearer token not found&quot;","ref":"Charon.TokenPlugs.html#get_token_from_auth_header/2","title":"Charon.TokenPlugs.get_token_from_auth_header/2","type":"function"},{"doc":"Appends the specified cookie's content to the bearer token, if the cookie is present and the token ends with a &quot;.&quot; character. Must be used after get_token_from_auth_header/2 . Doctests iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token , &quot;token.&quot; ) |&gt; put_req_cookie ( &quot;c&quot; , &quot;sig&quot; ) |&gt; fetch_cookies ( ) iex&gt; conn = conn |&gt; get_token_sig_from_cookie ( &quot;c&quot; ) iex&gt; conn |&gt; Utils . get_token_signature_transport ( ) :cookie iex&gt; conn |&gt; Internal . get_private ( @bearer_token ) &quot;token.sig&quot; # cookie is ignored if bearer token does not end with . iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token , &quot;token&quot; ) |&gt; put_req_cookie ( &quot;c&quot; , &quot;sig&quot; ) |&gt; fetch_cookies ( ) iex&gt; conn = conn |&gt; get_token_sig_from_cookie ( &quot;c&quot; ) iex&gt; conn |&gt; Utils . get_token_signature_transport ( ) nil iex&gt; conn |&gt; Internal . get_private ( @bearer_token ) &quot;token&quot;","ref":"Charon.TokenPlugs.html#get_token_sig_from_cookie/2","title":"Charon.TokenPlugs.get_token_sig_from_cookie/2","type":"function"},{"doc":"Fetch the session to which the bearer token belongs. Raises on session store error. Must be used after verify_token_signature/2 . Doctests iex&gt; command ( [ &quot;SET&quot; , session_key ( &quot;a&quot; , 1 ) , % Session { expires_at : 0 } |&gt; Session . serialize ( ) ] ) iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ &quot;sid&quot; =&gt; &quot;a&quot; , &quot;sub&quot; =&gt; 1 } ) iex&gt; % Session { } = conn |&gt; load_session ( @config ) |&gt; Internal . get_private ( @session ) # token payload must contain &quot;sub&quot; and &quot;sid&quot; claims iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , 1 ) iex&gt; conn |&gt; load_session ( @config ) |&gt; Utils . get_auth_error ( ) &quot;claim sub or sid not found&quot; # session must be found iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ &quot;sid&quot; =&gt; &quot;a&quot; , &quot;sub&quot; =&gt; 1 } ) iex&gt; conn |&gt; load_session ( @config ) |&gt; Utils . get_auth_error ( ) &quot;session not found&quot;","ref":"Charon.TokenPlugs.html#load_session/2","title":"Charon.TokenPlugs.load_session/2","type":"function"},{"doc":"Make sure that no previous plug of this module added an auth error. In case of an error, on_error is called (it must halt the connection!). Doctests iex&gt; conn = conn ( ) iex&gt; ^ conn = verify_no_auth_error ( conn , fn _conn , _error -&gt; &quot;BOOM&quot; end ) # on error, send an error response iex&gt; conn = conn ( ) |&gt; Internal . auth_error ( &quot;oops!&quot; ) iex&gt; conn = verify_no_auth_error ( conn , &amp; &amp;1 |&gt; send_resp ( 401 , &amp;2 ) |&gt; halt ( ) ) iex&gt; conn . halted true iex&gt; conn . resp_body &quot;oops!&quot;","ref":"Charon.TokenPlugs.html#verify_no_auth_error/2","title":"Charon.TokenPlugs.verify_no_auth_error/2","type":"function"},{"doc":"Verify that the refresh token has not been used yet (= that it matches the token id stored in the session). Must be used after load_session/2 . Verify the token type with verify_token_claim_equals/2 . Doctests iex&gt; conn = conn ( ) |&gt; put_private ( @session , %{ refresh_token_id : &quot;a&quot; } ) |&gt; put_private ( @bearer_token_payload , %{ &quot;jti&quot; =&gt; &quot;a&quot; } ) iex&gt; ^ conn = conn |&gt; verify_refresh_token_fresh ( [ ] ) # token&#39;s jti claim does not match session&#39;s refresh_token_id iex&gt; conn = conn ( ) |&gt; put_private ( @session , %{ refresh_token_id : &quot;a&quot; } ) |&gt; put_private ( @bearer_token_payload , %{ &quot;jti&quot; =&gt; &quot;b&quot; } ) iex&gt; conn |&gt; verify_refresh_token_fresh ( [ ] ) |&gt; Utils . get_auth_error ( ) &quot;refresh token stale&quot; # token&#39;s jti claim missing iex&gt; conn = conn ( ) |&gt; put_private ( @session , %{ refresh_token_id : &quot;a&quot; } ) |&gt; put_private ( @bearer_token_payload , %{ } ) iex&gt; conn |&gt; verify_refresh_token_fresh ( [ ] ) |&gt; Utils . get_auth_error ( ) &quot;claim jti not found&quot;","ref":"Charon.TokenPlugs.html#verify_refresh_token_fresh/2","title":"Charon.TokenPlugs.verify_refresh_token_fresh/2","type":"function"},{"doc":"Generically verify that the bearer token payload contains claim and that its value matches func . The function must return the conn or an error message. Must be used after verify_token_signature/2 . Doctests def verify_read_scope ( conn , value ) do if &quot;read&quot; in String . split ( value , &quot;,&quot; ) do conn else &quot;no read scope&quot; end end iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ &quot;scope&quot; =&gt; &quot;read,write&quot; } ) iex&gt; ^ conn = conn |&gt; verify_token_claim ( { &quot;scope&quot; , &amp; verify_read_scope / 2 } ) # invalid iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ &quot;scope&quot; =&gt; &quot;write&quot; } ) iex&gt; conn |&gt; verify_token_claim ( { &quot;scope&quot; , &amp; verify_read_scope / 2 } ) |&gt; Utils . get_auth_error ( ) &quot;no read scope&quot; # claim must be present iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ } ) iex&gt; conn |&gt; verify_token_claim ( { &quot;scope&quot; , &amp; verify_read_scope / 2 } ) |&gt; Utils . get_auth_error ( ) &quot;claim scope not found&quot;","ref":"Charon.TokenPlugs.html#verify_token_claim/2","title":"Charon.TokenPlugs.verify_token_claim/2","type":"function"},{"doc":"Verify that the bearer token payload contains claim and that its value is expected . Must be used after verify_token_signature/2 . Doctests iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ &quot;type&quot; =&gt; &quot;access&quot; } ) iex&gt; ^ conn = conn |&gt; verify_token_claim_equals ( { &quot;type&quot; , &quot;access&quot; } ) # invalid iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ &quot;type&quot; =&gt; &quot;refresh&quot; } ) iex&gt; conn |&gt; verify_token_claim_equals ( { &quot;type&quot; , &quot;access&quot; } ) |&gt; Utils . get_auth_error ( ) &quot;bearer token claim type invalid&quot; # claim must be present iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ } ) iex&gt; conn |&gt; verify_token_claim_equals ( { &quot;type&quot; , &quot;access&quot; } ) |&gt; Utils . get_auth_error ( ) &quot;claim type not found&quot;","ref":"Charon.TokenPlugs.html#verify_token_claim_equals/2","title":"Charon.TokenPlugs.verify_token_claim_equals/2","type":"function"},{"doc":"Verify that the bearer token payload contains claim and that its value is in expected . Must be used after verify_token_signature/2 . Doctests iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ &quot;type&quot; =&gt; &quot;access&quot; } ) iex&gt; ^ conn = conn |&gt; verify_token_claim_in ( { &quot;type&quot; , ~w(access) } ) # invalid iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ &quot;type&quot; =&gt; &quot;refresh&quot; } ) iex&gt; conn |&gt; verify_token_claim_in ( { &quot;type&quot; , ~w(access) } ) |&gt; Utils . get_auth_error ( ) &quot;bearer token claim type invalid&quot; # claim must be present iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ } ) iex&gt; conn |&gt; verify_token_claim_in ( { &quot;type&quot; , ~w(access) } ) |&gt; Utils . get_auth_error ( ) &quot;claim type not found&quot;","ref":"Charon.TokenPlugs.html#verify_token_claim_in/2","title":"Charon.TokenPlugs.verify_token_claim_in/2","type":"function"},{"doc":"Verify that the bearer token payload contains a non-expired exp (expires at) claim. Must be used after verify_token_signature/2 . Note that a token created by Charon.SessionPlugs.upsert_session/3 is guaranteed to have an exp claim that does not outlive its underlying session. Doctests iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ &quot;exp&quot; =&gt; Internal . now ( ) } ) iex&gt; ^ conn = conn |&gt; verify_token_exp_claim ( [ ] ) # some clock drift is allowed iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ &quot;exp&quot; =&gt; Internal . now ( ) - 3 } ) iex&gt; ^ conn = conn |&gt; verify_token_exp_claim ( [ ] ) # expired iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ &quot;exp&quot; =&gt; Internal . now ( ) - 6 } ) iex&gt; conn |&gt; verify_token_exp_claim ( [ ] ) |&gt; Utils . get_auth_error ( ) &quot;bearer token expired&quot; # claim must be present iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ } ) iex&gt; conn |&gt; verify_token_exp_claim ( [ ] ) |&gt; Utils . get_auth_error ( ) &quot;claim exp not found&quot;","ref":"Charon.TokenPlugs.html#verify_token_exp_claim/2","title":"Charon.TokenPlugs.verify_token_exp_claim/2","type":"function"},{"doc":"Verify that the bearer token payload contains a valid nbf (not before) claim. Must be used after verify_token_signature/2 . Doctests iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ &quot;nbf&quot; =&gt; Internal . now ( ) } ) iex&gt; ^ conn = conn |&gt; verify_token_nbf_claim ( [ ] ) # some clock drift is allowed iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ &quot;nbf&quot; =&gt; Internal . now ( ) + 3 } ) iex&gt; ^ conn = conn |&gt; verify_token_nbf_claim ( [ ] ) # not yet valid iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ &quot;nbf&quot; =&gt; Internal . now ( ) + 6 } ) iex&gt; conn |&gt; verify_token_nbf_claim ( [ ] ) |&gt; Utils . get_auth_error ( ) &quot;bearer token not yet valid&quot; # claim must be present iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ } ) iex&gt; conn |&gt; verify_token_nbf_claim ( [ ] ) |&gt; Utils . get_auth_error ( ) &quot;claim nbf not found&quot;","ref":"Charon.TokenPlugs.html#verify_token_nbf_claim/2","title":"Charon.TokenPlugs.verify_token_nbf_claim/2","type":"function"},{"doc":"Verify that the bearer token found by get_token_from_auth_header/2 is signed correctly. Doctests iex&gt; token = sign ( &quot;hurray!&quot; ) iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token , token ) |&gt; verify_token_signature ( @config ) iex&gt; Internal . get_private ( conn , @bearer_token_payload ) &quot;hurray!&quot; # signature must match iex&gt; token = sign ( &quot;hurray!&quot; ) iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token , token &lt;&gt; &quot;boom&quot; ) |&gt; verify_token_signature ( @config ) iex&gt; Internal . get_private ( conn , @bearer_token_payload ) nil iex&gt; Utils . get_auth_error ( conn ) &quot;bearer token signature invalid&quot;","ref":"Charon.TokenPlugs.html#verify_token_signature/2","title":"Charon.TokenPlugs.verify_token_signature/2","type":"function"},{"doc":"After verifying everything you would want to verify about a token, assign the following to the conn: :user_id :session_id :token_payload :session (if fetched with Charon.TokenPlugs.load_session/2 ) All of the assign names are overridable: # assign the user ID to key :current_user_id plug PutAssigns , user_id : :current_user_id Doctests iex&gt; opts = PutAssigns . init ( [ ] ) iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ &quot;sub&quot; =&gt; 1 , &quot;sid&quot; =&gt; &quot;a&quot; } ) iex&gt; conn |&gt; PutAssigns . call ( opts ) |&gt; Map . get ( :assigns ) %{ session_id : &quot;a&quot; , token_payload : %{ &quot;sid&quot; =&gt; &quot;a&quot; , &quot;sub&quot; =&gt; 1 } , user_id : 1 } iex&gt; opts = PutAssigns . init ( session : :da_session_baby ) iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ &quot;sub&quot; =&gt; 1 , &quot;sid&quot; =&gt; &quot;a&quot; } ) |&gt; put_private ( @session , &quot;hii&quot; ) iex&gt; conn |&gt; PutAssigns . call ( opts ) |&gt; Map . get ( :assigns ) %{ session_id : &quot;a&quot; , token_payload : %{ &quot;sid&quot; =&gt; &quot;a&quot; , &quot;sub&quot; =&gt; 1 } , user_id : 1 , da_session_baby : &quot;hii&quot; } # skipped on auth error iex&gt; opts = PutAssigns . init ( [ ] ) iex&gt; conn = conn ( ) |&gt; put_private ( @bearer_token_payload , %{ &quot;sub&quot; =&gt; 1 , &quot;sid&quot; =&gt; &quot;a&quot; } ) |&gt; Internal . auth_error ( &quot;boom&quot; ) iex&gt; conn |&gt; PutAssigns . call ( opts ) |&gt; Map . get ( :assigns ) %{ }","ref":"Charon.TokenPlugs.PutAssigns.html","title":"Charon.TokenPlugs.PutAssigns","type":"module"},{"doc":"Utility functions, mainly getters and setters for module internals.","ref":"Charon.Utils.html","title":"Charon.Utils","type":"module"},{"doc":"Get auth errors, if present.","ref":"Charon.Utils.html#get_auth_error/1","title":"Charon.Utils.get_auth_error/1","type":"function"},{"doc":"Get the payload of the bearer token, if present.","ref":"Charon.Utils.html#get_bearer_token_payload/1","title":"Charon.Utils.get_bearer_token_payload/1","type":"function"},{"doc":"Get current session, if present.","ref":"Charon.Utils.html#get_session/1","title":"Charon.Utils.get_session/1","type":"function"},{"doc":"Get token signature transport mechanism, if present.","ref":"Charon.Utils.html#get_token_signature_transport/1","title":"Charon.Utils.get_token_signature_transport/1","type":"function"},{"doc":"Get tokens, if present.","ref":"Charon.Utils.html#get_tokens/1","title":"Charon.Utils.get_tokens/1","type":"function"},{"doc":"Set token signature transport mechanism. Must be one of &quot;bearer&quot; , &quot;cookie&quot; , :bearer or :cookie . Examples / doctests iex&gt; :bearer = % Conn { } |&gt; set_token_signature_transport ( &quot;bearer&quot; ) |&gt; get_token_signature_transport ( ) iex&gt; :bearer = % Conn { } |&gt; set_token_signature_transport ( :bearer ) |&gt; get_token_signature_transport ( ) iex&gt; :cookie = % Conn { } |&gt; set_token_signature_transport ( &quot;cookie&quot; ) |&gt; get_token_signature_transport ( ) iex&gt; :cookie = % Conn { } |&gt; set_token_signature_transport ( :cookie ) |&gt; get_token_signature_transport ( ) iex&gt; set_token_signature_transport ( % Conn { } , &quot;anything else&quot; ) ** (FunctionClauseError) no function clause matching in Charon.Internal.parse_sig_transport/1","ref":"Charon.Utils.html#set_token_signature_transport/2","title":"Charon.Utils.set_token_signature_transport/2","type":"function"},{"doc":"Set user id for session creation","ref":"Charon.Utils.html#set_user_id/2","title":"Charon.Utils.set_user_id/2","type":"function"},{"doc":"Charon is an extensible auth framework for Elixir, mostly for API's. The base package provides token generation &amp; verification, and session handling. Additional functionality can be added with child packages. The package is opinionated with sane config defaults as much as possible.","ref":"readme.html","title":"Charon","type":"extras"},{"doc":"Charon Table of contents Features Child packages Documentation How to use Installation Configuration Setting up a session store RedisStore session cleanup Protecting routes Logging in, logging out and refreshing","ref":"readme.html#table-of-contents","title":"Charon - Table of contents","type":"extras"},{"doc":"Striking a &quot;statefulness&quot; balance is left to the application. Tokens can be fully stateless, but are backed by a server-side session. Tokens are generated by a factory behaviour with a default implementation using symmetric-key JWT's. Token verification is completely customizable. Sessions are managed by a session store behaviour with a default implementation using Redis. To support both web- and other clients, it is possible to &quot;split-off&quot; the token's signatures and put them in cookies (to prevent storing tokens in LocalStorage and other insecure storage). This idea is inspired by this excellent Medium article by Peter Locke. Flexible configuration that does not depend on the application environment. Small number of dependencies.","ref":"readme.html#features","title":"Charon - Features","type":"extras"},{"doc":"CharonAbsinthe for using Charon with Absinthe. CharonOauth2 adds Oauth2 authorization server capability. (planned) CharonLogin adds authentication flows/challenges to generically provide login checks like password and MFA. (planned) CharonSocial for social login. (planned) CharonPermissions for authorization checks.","ref":"readme.html#child-packages","title":"Charon - Child packages","type":"extras"},{"doc":"Documentation can be found at https://hexdocs.pm/charon .","ref":"readme.html#documentation","title":"Charon - Documentation","type":"extras"},{"doc":"Installation The package can be installed by adding charon to your list of dependencies in mix.exs : def deps do [ { :charon , &quot;~&gt; 1.3.0-beta&quot; } , # to use the default Charon.TokenFactory.SymmetricJwt { :jason , &quot;~&gt; 1.0&quot; } ] end Configuration Configuration has been made easy using a config helper struct Charon.Config , which has a function from_enum/1 that verifies that your config is complete and valid, raising on missing fields. By using multiple config structs, you can support multiple configurations within a single application. The main reason to use multiple sets of configuration is that you can support different auth requirements in this way. You could, for example, create a never-expiring session for ordinary users and create a short-lived session for application admins. # Charon itself only requires a token issuer. # The default implementations of session store and token factory require some config as well. @my_config Charon.Config . from_enum ( token_issuer : &quot;MyApp&quot; , optional_modules : %{ Charon.TokenFactory.SymmetricJwt =&gt; %{ get_secret : &amp; MyApp . get_jwt_secret / 0 } , Charon.SessionStore.RedisStore =&gt; %{ redix_module : MyApp.Redix } } ) # it is possible to use the application environment as well if you wish @my_config Application . compile_env ( :my_app , :charon ) |&gt; Charon.Config . from_enum ( ) Setting up a session store A session store can be created using multiple state stores, be it a database or a GenServer. All you have to do is implement a simple behaviour which you can find in Charon.SessionStore . A default implementation using Redis is provided by Charon.SessionStore.RedisStore , as is a dummy store ( Charon.SessionStore.DummyStore ) in case you don't want to use server-side session and prefer fully stateless tokens. RedisStore session cleanup The default Charon.SessionStore.RedisStore has a cleanup/1 function that should run periodically, for example using Quantum . Protecting routes Verifying incoming tokens is supported by the plugs in Charon.TokenPlugs (and submodules). You can use these plugs to create pipelines to verify the tokens and their claims. Note that the plugs don't halt the connection until you call Charon.TokenPlugs.verify_no_auth_error/2 , but further processing stops as soon as a previous plug adds an error to the conn. Example access- and refresh token pipelines: defmodule MyApp.AccessTokenPipeline do @moduledoc &quot;&quot;&quot; Verify access tokens. A access token: - must have a valid signature - must not be expired (and already valid) - must have a &quot;type&quot; claim with value &quot;access&quot; &quot;&quot;&quot; use Plug.Builder @config Application . compile_env ( :my_app , :charon ) |&gt; Charon.Config . from_enum ( ) plug :get_token_from_auth_header plug :get_token_sig_from_cookie , @config . access_cookie_name plug :verify_token_signature , @config plug :verify_token_nbf_claim plug :verify_token_exp_claim plug :verify_token_claim_equals , { &quot;type&quot; , &quot;access&quot; } plug :verify_no_auth_error , &amp; MyApp.TokenErrorHandler . on_error / 2 plug Charon.TokenPlugs.PutAssigns end defmodule MyApp.RefreshTokenPipeline do @moduledoc &quot;&quot;&quot; Verify refresh tokens. A refresh token: - must have a valid signature - must not be expired (and already valid) - must have a &quot;type&quot; claim with value &quot;refresh&quot; - must have a corresponding session - must match the ID stored in the session &quot;&quot;&quot; use Plug.Builder @config Application . compile_env ( :my_app , :charon ) |&gt; Charon.Config . from_enum ( ) plug :get_token_from_auth_header plug :get_token_sig_from_cookie , @config . refresh_cookie_name plug :verify_token_signature , @config plug :verify_token_nbf_claim plug :verify_token_exp_claim plug :verify_token_claim_equals , { &quot;type&quot; , &quot;refresh&quot; } plug :load_session , @config plug :verify_refresh_token_fresh plug :verify_no_auth_error , &amp; MyApp.TokenErrorHandler . on_error / 2 plug Charon.TokenPlugs.PutAssigns end # use the pipelines in your router defmodule MyAppWeb.Router do use MyAppWeb , :router pipeline :api do plug :accepts , [ &quot;json&quot; ] end pipeline :valid_access_token do plug MyApp.AccessTokenPipeline end pipeline :valid_refresh_token do plug MyApp.RefreshTokenPipeline end scope &quot;/&quot; do pipe_through [ :api ] post &quot;/current_session&quot; , SessionController , :login end scope &quot;/&quot; do pipe_through [ :api , :valid_access_token ] delete &quot;/current_session&quot; , SessionController , :logout end scope &quot;/&quot; do pipe_through [ :api , :valid_refresh_token ] # optionally limit the refresh cookie path to this path using `Config.refresh_cookie_opts` post &quot;/current_session/refresh&quot; , SessionController , :refresh end end Logging in, logging out and refreshing Create a session controller with login, logout and refresh routes. You can use Charon.SessionPlugs for all operations. defmodule MyAppWeb.SessionController do @moduledoc &quot;&quot;&quot; Controller for a user&#39;s session(s), including login, logout and refresh. &quot;&quot;&quot; use MyAppWeb , :controller alias Charon . { SessionPlugs , Utils } alias MyApp . { User , Users } @config Application . compile_env ( :my_app , :charon ) |&gt; Charon.Config . from_enum ( ) def login ( conn , %{ &quot;email&quot; =&gt; email , &quot;password&quot; =&gt; password , &quot;token_signature_transport&quot; =&gt; signature_transport } ) when signature_transport in ~w(bearer cookie) do with { :ok , user } &lt;- Users . get_by ( email : email ) |&gt; Users . verify_password ( password ) do # you can do extra checks here, like checking if the user is active, for example conn |&gt; Utils . set_user_id ( user . id ) |&gt; Utils . set_token_signature_transport ( signature_transport ) # you can add/override claims in the tokens (be careful!) |&gt; SessionPlugs . upsert_session ( @config , access_claim_overrides : %{ &quot;roles&quot; =&gt; user . roles } ) |&gt; put_status ( 201 ) |&gt; send_token_response ( user ) else _error -&gt; send_resp ( conn , 401 , &quot;user not found or wrong password&quot; ) end end def logout ( conn , _params ) do conn |&gt; SessionPlugs . delete_session ( @config ) |&gt; send_resp ( 204 , &quot;&quot; ) end def refresh ( %{ assigns : %{ current_user_id : user_id } } = conn , _params ) do with % User { status : &quot;active&quot; } = user &lt;- Users . get_by ( id : user_id ) do # here you can do extra checks again conn # there&#39;s no need to set user_id, token signature transport or extra session payload again # but all added/overridden token claims must be passed in again |&gt; SessionPlugs . upsert_session ( @config , access_claim_overrides : %{ &quot;roles&quot; =&gt; user . roles } ) |&gt; send_token_response ( user ) else _error -&gt; send_resp ( conn , 401 , &quot;user not found or inactive&quot; ) end end ########### # Private # ########### defp send_token_response ( conn , user ) do session = conn |&gt; Utils . get_session ( ) |&gt; Map . from_struct ( ) tokens = conn |&gt; Utils . get_tokens ( ) |&gt; Map . from_struct ( ) json ( conn , %{ tokens : tokens , session : session } ) end end And that's it :) Optionally, you can add get-all, logout-all and logout-other session endpoints, if your session store supports it (the default Redis one does).","ref":"readme.html#how-to-use","title":"Charon - How to use","type":"extras"}]